'use strict';

apiServices.factory('APIBase', function ($log, RestBeWin) {


    var api = function (entityClass) {
        this.entityClass = entityClass;
    };

    api.prototype.loadAll = function () {
        $log.log("loadAll>", this.entityClass);
        return RestBeWin.all(this.entityClass).getList();
    };

    api.prototype.loadOne = function (entityId) {
        return RestBeWin.stripRestangular(
            RestBeWin.one(this.entityClass, entityId).get()
        );
    };

    api.prototype.deleteOne = function (entityId) {
        return RestBeWin.one(this.entityClass, entityId).remove({});
    };

    api.prototype.save = function (entity) {
        if (entity.id) {
            $log.log("Updating >", entity);
            return RestBeWin.restangularizeElement(null, RestBeWin.stripRestangular(entity), this.entityClass).put();
        }
        $log.log("Creating >", entity);
        return RestBeWin.all(this.entityClass).post(entity);
    };

    api.prototype.update = function (entity) {
        if (entity.id) {
            $log.log("Updating >", entity);
            return RestBeWin.restangularizeElement(null, RestBeWin.stripRestangular(entity), this.entityClass).put();
        }
        $log.log("Creating >", entity);
        return RestBeWin.all(this.entityClass).post(entity);
    };

    api.prototype.list = function () {
        return RestBeWin.all(this.entityClass).one('list').getList();
    };

    api.prototype.search = function (map) {
        return RestBeWin.all(this.entityClass).one('search').customPOST(map);
    };

    return api;
});
