'use strict';

apiServices.factory('APIDevice', function ($log, RestBeWin, APIBase) {
    var api = new APIBase('device');

    api.byUuid = function (uuid) {
        return RestBeWin.one(this.entityClass).one('uuid', uuid).get();
    };

    api.byQueue = function (queueId) {
        return RestBeWin.all(this.entityClass).one('queue', queueId).getList();
    };

    api.byQueueDeleted = function (queueId) {
        var parameter = {
            "queue_id": queueId,
            "active": false
        };
        return api.search(parameter);
    };

    api.deactivate = function (deviceId) {
        return RestBeWin.one(this.entityClass).one('deactivate', deviceId).post();
    };

    api.activate = function (deviceId) {
        return RestBeWin.one(this.entityClass).one('activate', deviceId).post();
    };

    return api;

});
