'use strict';

apiServices.factory('APIOperationsProfile', function ($log, RestBeWin, APIBase) {
    var api = new APIBase('operationsprofile');

    api.byTenant = function (tenantId) {
        return RestBeWin.all(this.entityClass).one('tenant', tenantId).getList();
    };

    api.byQueueService = function (queueId, serviceId) {
        return RestBeWin.all(this.entityClass).one('queue', queueId).one('service', serviceId).get();
    };

    api.workProfile = function (operationsprofileId) {
        return RestBeWin.one(this.entityClass, operationsprofileId).all('workprofile').getList();
    };

    api.removeWorkProfile = function (operationsprofileId, entityId) {
        return RestBeWin.one(this.entityClass, operationsprofileId).one('workprofile', entityId).remove({});
    };

    api.addWorkProfile = function (operationsprofileId, entity) {

        $log.log("Updating>", entity)
        if (entity.id) {
            $log.log("Updating >", entity);
        } else {
            $log.log("Creating >", entity);
        }

        return RestBeWin.one(this.entityClass, operationsprofileId).all('workprofile').post(entity);
    };

    return api;
});

