'use strict';

apiServices.factory('APIServicePoint', function ($log, RestBeWin, APIBase) {
    var api = new APIBase('servicepoint');

    api.byTenant = function (tenantId) {
        return RestBeWin.all(this.entityClass).one('findByTenant', tenantId).getList();
    };

    api.byOperationsProfile = function (profileId) {
        return RestBeWin.all(this.entityClass).one('findByOperationsProfile', profileId).getList();
    };

    api.byQueue = function (queueId) {
        return RestBeWin.all(this.entityClass).one('findByQueue', queueId).getList();
    };

    api.checkSequence = function (tenantId, letter, minNum, maxNum) {
        return RestBeWin.all(this.entityClass).customGET('checkSequence', {
            tenantId: tenantId,
            letter: letter,
            minNum: minNum,
            maxNum: maxNum
        });
    };

    return api;

});
