'use strict';

apiServices.factory('APIStats', function ($log, RestBeWin, APIBase) {

    var api = new APIBase('stats');

    api.byTicket = function (ticket) {
        var spid = (ticket.servicePoint || {id: null}).id;
        var qid = (ticket.queue || {id: null}).id;

        var t = {
            id: ticket.id,
            servicePoint: {
                id: spid
            },
            queue: {
                id: qid
            }
        };
        return RestBeWin.one(this.entityClass).one('ticket').customPOST(t);
    };

    api.byQueue = function (queueId) {
        return RestBeWin.one(this.entityClass).one('queue', queueId).get();
    };

    api.queueByServicePoint = function (queueId) {
        return RestBeWin.one(this.entityClass).one('waitByService', queueId).getList();
    };

    api.serveredByServicePoint = function (queueId) {
        return RestBeWin.one(this.entityClass).one('servedByService', queueId).getList();
    };

    api.servicedBy = function (queueId) {
        return RestBeWin.one(this.entityClass).one('servicedBy', queueId).getList();
    };

    return api;
});
