'use strict';

apiServices.factory('APIUser', function ($log, RestBeWin, APIBase) {
    var api = new APIBase('user');

    api.byTenant = function (tenantId) {
        return RestBeWin.all(this.entityClass).one('tenant', tenantId).getList();
    };

    api.byId = function (id) {
        return RestBeWin.one(this.entityClass).one('/', id).get();
    };

    api.workprofiles = function (userid) {
        return RestBeWin.all(this.entityClass + '/' + userid).one('workprofiles').getList();
    };

    api.workingInQueue = function (queueId) {
        return RestBeWin.all(this.entityClass).one('inservice', queueId).getList();
    };

    api.joinStation = function (userId, queueId, workProfileId, stationId) {
        $log.log("joinStation > ", userId, queueId, workProfileId, stationId);

        return RestBeWin.one(this.entityClass).one('inservice').customPUT({
                id: userId,
                currentQueue: {
                    id: queueId
                },
                currentWorkProfile: {
                    id: workProfileId
                },
                currentStation: {
                    id: stationId
                }
            }
        );
    };

    api.outInservice = function (userId) {

        $log.log("outInservice > ", userId);

        return RestBeWin.one(this.entityClass).one('outInservice').customPUT(
            {
                id: userId
            }
        );
    };

    api.servingTicket = function (userId) {
        $log.log("servingTicket > ", userId);

        return RestBeWin.one(this.entityClass + '/' + userId).one('servingTicket').get();
    };

    api.findByWorkprofile = function (tenantId, wpId) {
        return RestBeWin.all(this.entityClass).one('tenant', tenantId).one('workprofiles', wpId).getList();
    };

    api.canUserLogout = function (queueId, userId) {
        var params = {
            "queueId": queueId,
            "userId": userId
        };
        return RestBeWin.all(this.entityClass).customGETLIST('canUserLogout', params);
    };

    api.joinUserQueue = function (userId, queueId) {
        return RestBeWin.one(this.entityClass).one('joinQueue').customPUT({
            id: userId,
            currentQueue: {
                id: queueId
            }
        });
    };

    return api;

});
