'use strict';

apiServices.factory('APIVariable', function ($log, RestBeWin, APIBase) {
    var api = new APIBase('variable');

    api.byQueue = function (qid) {
        return RestBeWin.all(this.entityClass).one('queue', qid).getList();
    };

    api.byTenant = function (tid) {
        return RestBeWin.all(this.entityClass).one('tenant', tid).getList();
    };

    api.byNameAndQueue = function (qid, kid) {
        return RestBeWin.all(this.entityClass).one('queue', qid).one('key', kid).get();
    };

    api.byNameAndTenant = function (tid, kid) {
        return RestBeWin.all(this.entityClass).one('tenant', tid).one('key', kid).get();
    };

    api.byName = function (kid) {
        return RestBeWin.all(this.entityClass).one('key', kid).get();
    };

    return api;

});
