'use strict';

apiAppointmentServices.factory('APIBaseAppointment', function ($log, RestAppointment) {

    var api = function (entityClass) {
        this.entityClass = entityClass;
    };

    api.prototype.findOne = function (id) {
        $log.log("findOne > ", this.entityClass);
        var params = {
            "id": id
        };
        return RestAppointment.all(this.entityClass).customGET('findOne', params);
    };

    api.prototype.list = function () {
        $log.log("list > ", this.entityClass);
        return RestAppointment.all(this.entityClass).one('list').getList();
    };

    api.prototype.search = function (map) {
        $log.log("search > ", this.entityClass);
        return RestAppointment.all(this.entityClass).one('search').customPOST(map);
    };

    api.prototype.save = function (entity) {
        $log.log("save > ", entity);
        return RestAppointment.all(this.entityClass).post(entity);
    };

    api.prototype.deleteOne = function (entityId) {
        $log.log("deleteOne > ", entityId);
        var params = {
            "id": entityId
        };
        return RestAppointment.all(this.entityClass).remove(params);
    };

    return api;
});
