'use strict';

apiAppointmentServices.factory('TimetableGroupingAPI', function (RestAppointment, APIBaseAppointment) {

    var api = new APIBaseAppointment('timetableGrouping');

    api.findGenerics = function (timeTableType) {
        var params = {
            "timeTableType": timeTableType
        };
        return RestAppointment.all(this.entityClass).customGETLIST('findGenerics', params);
    };

    api.saveWithTimetable = function (entity) {
        return RestAppointment.all(this.entityClass).one("saveWithTimetable").customPOST(entity);
    };

    api.findByQueue = function (queueId, timeTableType) {
        var params = {
            "queueId": queueId,
            "timeTableType": timeTableType
        };
        return api.search(params);
    };

    return api;

});