'use strict';

angular.module('bewin_orange')
    .controller('MainCtrl', function ($scope, $state, $window, APIAuth, APIUser, modalService, sessionService,
                                      NavigationServices) {

        angular.element($window).bind('orientationchange', function () {
            $scope.$apply();
            $(".toggle-menu").removeAttr('style');
        });

        $scope.session = sessionService;

        $scope.logout = function () {

            if (sessionService.user || sessionService.user.roles) {

                if (sessionService.getQueue() !== null) {

                    var k = _.find(sessionService.user.roles, function (r) {
                        if (r.authority == 'STATION_CAJA_ROLE' || r.authority == 'STATION_ROLE') {
                            return true;
                        } else {
                            return false;
                        }
                    });

                    if (typeof k != 'undefined' && k.authority != 'undefined' && (k.authority == 'STATION_ROLE' || k.authority == 'STATION_CAJA_ROLE')) {

                        if (sessionService.isServing) {
                            var msg = 'Por favor, cierre el ticket en servicio antes de cerrar la sesión.';
                            modalService.open('views/common/modal_warning.html', 'WarningCtrl', msg, null);
                        } else {
                            NavigationServices.canUserLogout().then(function (response) {
                                if (response) {
                                    APIAuth.logout();
                                    $state.go('login');
                                }
                            });
                        }
                    } else {
                        APIAuth.logout();
                        $state.go('login');
                    }
                }
                else {
                    APIAuth.logout();
                    $state.go('login');
                }
            }
        };

        $scope.hasRole = function (r) {

            if (!$scope.session.user || !$scope.session.user.roles) return false;

            var k = _.find($scope.session.user.roles, ['authority', r]);

            if (!k || k === undefined)
                return false;

            return true;
        };

        $scope.hasMoreQueues = function () {
            return sessionService.user.queues.length > 1;
        };

        $scope.toggleMenu = function () {
            var width = angular.element($window).width();
            if (width <= 992) {
                $(".toggle-menu").toggle();
            }
        };

        $scope.changeCurrentQueue = function () {
            NavigationServices.changeCurrentQueue();
        };

        $(".toggle-menu").removeAttr('style');

    });