'use strict';

angular
    .module('bewin_orange')
    .directive('pageTitle', ['$timeout', '$transitions', function ($timeout, $transitions) {
        return {
            restrict: 'A',
            link: function (scope, element) {
                var listener = function (event, toState, toParams, fromState, fromParams) {
                    // Default title - load on Dashboard 1
                    var title = 'BeWin - El sistema que no te hace esperar';
                    $timeout(function () {
                        element.text(title);
                    });
                };
                $transitions.onSuccess({}, listener);
            }
        }
    }])
    .directive('sideNavigation', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element) {
                // Call the metsiMenu plugin and plug it to sidebar navigation
                $timeout(function () {
                    element.metisMenu();
                });
            }
        }
    }])
    .directive('focusMe', ['$timeout', function ($timeout) {
        return {
            link: function (scope, element, attrs) {
                console.log('focus-me=', attrs.focusMe);
                scope.$watch(attrs.focusMe, function (value) {
                    console.log('value=', value);
                    if (value === true) {
                        $timeout(function () {
                            element[0].focus();
                        });

                    }
                });

            }
        }
    }])
    .directive('jqueryDatePicker', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                // Call the jquery plugin and plug it to element
                $timeout(function () {
                    $(element).datepicker({
                        showOn: "button",
                        buttonImage: "images/calendar.svg",
                        changeMonth: true,
                        changeYear: false,
                        showButtonPanel: false,
                        dateFormat: 'dd/mm'
                    });
                });
            }
        }
    }])
    .directive('jqueryDateYearPicker', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                // Call the jquery plugin and plug it to element
                $timeout(function () {
                    $(element).datepicker({
                        showOn: "button",
                        buttonImage: "images/calendar.svg",
                        changeMonth: true,
                        changeYear: true,
                        showButtonPanel: false,
                        dateFormat: 'yy-mm-dd'
                    });
                });
            }
        }
    }])
    .filter('trustAsResourceUrl', ['$sce', function ($sce) {
        return function (val) {
            return $sce.trustAsResourceUrl(val);
        };
    }]);