'use strict';

services.factory('FestiveServices', function (toastr, modalService, FestiveAPI, FestiveGroupingAPI) {

    var festiveServices = {};

    festiveServices.selectFestiveGrouping = function (q, form, genericFestiveGrouping) {
        FestiveGroupingAPI.findByQueue(q.id).then(function (response2) {
            if(response2.length > 0){
                form.festiveGrouping = JSON.parse(JSON.stringify(response2[0]));
                if (form.festiveGrouping.extend !== undefined) {
                    form.festiveGrouping.extend = _.find(genericFestiveGrouping, ['id', form.festiveGrouping.extend.id]);
                } else {
                    form.festiveGrouping.extend = genericFestiveGrouping[0];
                }
            } else {
                form.festiveGrouping = {};
                form.festiveGrouping.extend = genericFestiveGrouping[0];
            }
        });
        FestiveAPI.obtainFestives(q.id, null,null).then(function (response3) {
            form.listfestive = response3;
        });
    };

    festiveServices.saveFestiveGrouping = function (form, genericFestiveGrouping) {
        form.festiveGrouping.queue = form.queue;
        FestiveGroupingAPI.save(form.festiveGrouping).then(function (r) {
            toastr.info("Festivo guardado correctamente", "Operación realizada");
            festiveServices.selectFestiveGrouping(form.queue, form, genericFestiveGrouping);
        });
    };

    festiveServices.saveFestive = function (form, model, genericFestiveGrouping) {
        model.festive.date = moment(form.festive.date + '/1900', "DD/MM/YYYY");

        if(form.festiveGrouping.id === undefined ){
            form.festiveGrouping.queue = form.queue;
            FestiveGroupingAPI.save(form.festiveGrouping).then(function (r) {

                model.festive.festiveGrouping = r;
                FestiveAPI.save(model.festive).then(function (r) {
                    toastr.info("Festivo guardado correctamente", "Operación realizada");
                    form.festive = {};
                    model.festive = {};
                    festiveServices.selectFestiveGrouping(form.queue, form, genericFestiveGrouping);
                });
            });

        } else {
            model.festive.festiveGrouping = form.festiveGrouping;
            FestiveAPI.save(model.festive).then(function (r) {
                toastr.info("Festivo guardado correctamente", "Operación realizada");
                form.festive = {};
                model.festive = {};
                festiveServices.selectFestiveGrouping(form.queue, form, genericFestiveGrouping);
            });
        }
    };


    festiveServices.removeFestive = function (festiveId, q, form, genericFestiveGrouping) {
        var msg = 'Se va a deshabilitar este festivo. ¿Desea continuar?';
        modalService.open('views/common/modal_delete.html', 'DeleteWarningCtrl', msg, null);
        var modalInstance = modalService.modalInstance;

        modalInstance.result.then(function () {
            FestiveAPI.deleteOne(festiveId).then(function (r) {
                toastr.info("Festivo eliminado correctamente", "Operación realizada");
                form.festive = {};
                festiveServices.selectFestiveGrouping(q, form, genericFestiveGrouping);
            });
        });
    };

    return festiveServices;
});