'use strict';

services.factory('modalService', function ($uibModal) {

    var modal = {
        opened: false,
        modalInstance: {}
    };

    modal.isOpen = function () {
        return modal.opened;
    };

    modal.close = function (result) {
        modal.modalInstance.close(result);
    };

    modal.dismiss = function (reason) {
        modal.modalInstance.dismiss(reason);
    };

    modal.open = function (content, controller, message, state) {
        modal.open(content,controller, message, state, null, null);
    };

    modal.open = function (content, controller, message, state, entity) {
        modal.open(content,controller, message, state, entity, null);
    };

    modal.open = function (content, controller, message, state, entity, reloadTime) {

        if (modal.opened === false) {

            //Set modalInstance
            modal.modalInstance = $uibModal.open({
                animation: true,
                templateUrl: content,
                controller: controller,
                backdrop  : 'static',
                keyboard  : false,
                resolve: {
                    msg: function () {
                        return message;
                    },
                    redirectState: function () {
                        return state;
                    },
                    entity: function () {
                        return entity;
                    },
                    reloadTime: function () {
                        return reloadTime;
                    }
                }
            });

            //Set open
            modal.opened = true;

            //Modal is closed/resolved/dismissed
            modal.modalInstance.result.finally(function () {
                modal.opened = false;
            });
        }
    };

    return modal;
});