'use strict';

services.factory('UserAccessService', function ($log, $http, configurationService, sessionService) {

        var service = {};

        service.logIn = function (userId, queueId) {
            return $http.get(configurationService.apiURL + '/useraccess/logIn', {
                headers: {
                    'X-Auth-Token': sessionService.securityToken
                },
                params: {
                    'userId': userId,
                    'queueId': queueId
                }
            });
        };

        service.logOut = function (userId) {
            return $http.get(configurationService.apiURL + '/useraccess/logOut', {
                headers: {
                    'X-Auth-Token': sessionService.securityToken
                },
                params: {
                    'userId': userId
                }
            });
        };

        return service;
    }
);