'use strict';

services.factory('utilService', function(  $log ) {
    var api = {};

	api.startToday = function( ) {
		var d = new Date();
		d.setHours(0,0,0,0);
		return d;
	};

	api.endToday = function() {
		var d = new Date();
		d.setHours(23,59,59,99);
		return d;	
	};

    api.firstDayOfMonth = function() {
        var d = new Date();
        return new Date( d.getFullYear(), d.getMonth(), 1, 0, 0, 0, 0 );
    };


    api.lastDayOfMonth = function() {
        var d = new Date();
        return new Date( d.getFullYear(), d.getMonth(), 31, 23, 59, 59, 0 );
    };

    api.firstDayOfYear = function() {
        var d = new Date();
        return new Date( d.getFullYear(), 0, 1, 0, 0, 0, 0 );
    };


    api.lastDayOfYear = function() {
        var d = new Date();
        return new Date( d.getFullYear(), 11, 31, 23, 59, 59, 0 );
    };   
    

    api.byID = function( c, id ) {
        return api.byAttr( 'id', c, id );
    };

    api.byName = function( c, id ) {
        return api.byAttr( 'name', c, id );
    };

    api.byAttr = function( attr, c, id ) {
        if( !c || !c.length ) return null;
        var res = c.filter( function(v) {
            return v[attr] == id;
        });
        
        if( !res || !res.length )
            return null;

        return res[0];
    };

    return api;
});
