'use strict';

angular.module('bewin_orange')
    .controller('SMSProviderAdminController', function ($scope, $log, $stateParams, sessionService, APISMSProvider, toastr) {
        $log.log("SMSProviderAdminController started ..");

        $scope.model = {
            smsproviders: [],
            smsprovider: {}
        };

        $scope.form = {
            smsprovider: {}
        };

        $scope.select = function (t) {
            if (t && t.id) {
                APISMSProvider.loadOne(t.id).then(function (response) {
                    $scope.model.smsprovider = response;
                    $scope.form.smsprovider = JSON.parse(JSON.stringify(response));
                });
            } else {
                $scope.model.smsprovider = t;
                $scope.form.smsprovider = {};
            }
        };

        $scope.cancel = function () {
            $scope.select({});
        };

        $scope.save = function () {
            APISMSProvider.update($scope.form.smsprovider).then(function (res) {
                $scope.select(res);
                toastr.info("Proveedor de SMS actualizado correctamente", "Operación realizada");
                loadAll();
            });
        };

        var loadAll = function () {
            $scope.model.smsproviders = APISMSProvider.list().$object;
        };

        loadAll();

    });
