'use strict';

angular.module('bewin_orange')
    .controller('LoginController', function ($scope, $log, $state, APIAuth, NavigationServices) {
        $log.log("LoginController started ..");

        $scope.form = {
            login: {
                username: '',
                password: '',
                errors: ''
            }
        };

        $scope.login = function () {
            $scope.form.login.errors = '';

            if ($scope.form.login.username === undefined || $scope.form.login.username === '') {
                $scope.form.login.errors = "Debe proporcionar un nombre de usuario";
            } else if ($scope.form.login.password === undefined || $scope.form.login.password === '') {
                $scope.form.login.errors = "Debe proporcionar una contraseña";
            } else {
                APIAuth.login($scope.form.login.username, $scope.form.login.password, function (principal) {

                    if (!principal.supportsRole('USER_ROLE')) {
                        $scope.form.login.errors = "El usuario carece de permisos para acceder.";
                        return;
                    }

                    if (principal.supportsRole('ADMIN_ROLE')) {
                        $state.go('admin.tenantadmin');
                        return;
                    }

                    if (principal.supportsRole('TENANT_ADMIN_ROLE')) {
                        $state.go('tenant.queue');
                        return;
                    }

                    NavigationServices.selectCurrentQueue(principal);
                }, function (response) {
                    if (response.data) {
                        $scope.form.login.errors = response.data.message;
                    } else if (response.status === -1) {
                        $scope.form.login.errors = "Se ha perdido la conexión con el servidor. Revise su conexión a la red.";
                    }
                });
            }
        };
    });