'use strict';

angular.module('bewin_orange')
    .controller('ReceptionHomeController', function ($scope, $stateParams, $state, sessionService, APIQueue, APIUser) {

        $scope.model = {
            user: sessionService.user,
            queues: []
        };

        $scope.form = {
            filter: []
        };

        $scope.nameQueueSort = 'name';

        $scope.selectQueue = function (queue) {
            // actualizamos el dato del usuario
            APIUser.joinUserQueue($scope.model.user.id, queue.id).then(function (resp) {

                var result = resp.plain();

                if (typeof result.currentQueue != 'undefined') {
                    $scope.model.user.currentQueue = result.currentQueue;
                    sessionService.setUser($scope.model.user);
                    $scope.showTicketForm();
                }
            });
        };

        $scope.showTicketForm = function () {
            $state.go('reception.ticket', {id: $scope.model.user.currentQueue.id});
        };

        $scope.cleanFilter = function () {
            $scope.form.filter = [];
        };

        var init = function () {
            $scope.model.queues = $scope.model.user.queues;

            // comprobamos si el usuario tiene seleccionado una tienda
            if (typeof $scope.model.user.currentQueue != 'undefined') {
                $scope.showTicketForm();
            }
        };

        init();
    });