'use strict';

angular.module('bewin_orange')
    .controller('SupervisionHomeController', function ($scope, $log, $stateParams, $state, sessionService, APIQueue, APIUser) {
        $log.log("SupervisionHomeController started ..");

        $scope.inUse = false;

        $scope.model = {
            user: sessionService.user,
            queues: []
        };

        $scope.form = {
            filter: []
        };

        $scope.nameQueueSort = 'name';

        $scope.selectQueue = function (queue) {

            // si el usuario no tiene Tienda selecionada
            if (typeof $scope.model.user.currentQueue == 'undefined') {

                // tiene una Tienda asignada
                if (sessionService.user.queues.length == 1) {
                    // actualizamos el dato del usuario
                    APIUser.joinUserQueue($scope.model.user.id, queue.id).then(function (result) {

                        if (typeof result.currentQueue != 'undefined') {
                            $scope.model.user.currentQueue = result.currentQueue;
                            sessionService.setUser($scope.model.user);
                            $scope.inUse = true;
                            $scope.showSupervisorDashboard($scope.model.user.currentQueue.id);
                        }
                    });
                } else {
                    // mostramos los datos de esa tienda, pero no la asignamos al usuario
                    $scope.showSupervisorDashboard(queue.id);
                }
            } else {
                // comprobamos si es igual que la seleccionada
                if ($scope.model.user.currentQueue.id == queue.id) {
                    $scope.showSupervisorDashboard($scope.model.user.currentQueue.id);
                } else {
                    $scope.showSupervisorDashboard(queue.id);
                }
            }
        };

        $scope.showSupervisorDashboard = function (queueId) {
            $state.go('supervision.dashboard', {id: queueId});
        };

        $scope.cleanFilter = function () {
            $scope.form.filter = [];
        };

        var init = function () {
            $scope.model.queues = $scope.model.user.queues;
            $scope.cleanFilter();

            // si el usuario tiene 1 sola tienda, lo enviamos a ella
            if ($scope.model.queues && $scope.model.queues.length === 1) {
                $scope.selectQueue($scope.model.queues[0]);
            } else {
                // comprobamos si el usuario tiene seleccionado una tienda y lo enviamos a ella, si no, se envia a la selsccion
                if (typeof $scope.model.user.currentQueue != 'undefined') {
                    $scope.inUse = true;
                    $scope.showSupervisorDashboard($scope.model.user.currentQueue.id);
                }
            }
        };

        init();
    });