'use strict';

angular.module('bewin_orange')
    .controller('QueueSupervisionController', function ($scope, $stateParams, sessionService, paginationService, FestiveServices,
                                                        TimetableServices, APIQueue, FestiveGroupingAPI, PromotionAPI,
                                                        PromotionGroupingAPI, TimetableGroupingAPI, TIMETABLE_TYPE) {

            $scope.model = {
                queues: [],
                queue: {},
                genericTimetableGrouping: TimetableGroupingAPI.findGenerics(TIMETABLE_TYPE.OPEN_CLOSE).$object,
                genericTimetableAppoiment: TimetableGroupingAPI.findGenerics(TIMETABLE_TYPE.APPOINTMENT).$object,
                genericFestiveGrouping: FestiveGroupingAPI.findGenerics().$object,
                festive: {},
                timetableGrouping: {},
                timetableGroupingAppoiment: {},
                showSaveTimetable: false,
                showSaveAppointments: false
            };

            $scope.form = {
                filter: '',
                queue: {},
                festiveGrouping: {},
                timetableGrouping: {},
                timetableGroupingAppoiment: {},
                listfestive: [],
                festive: {},
                image_base64: ''
            };

            $scope.select = function (q) {
                if (q && q.id) {
                    APIQueue.loadOne(q.id).then(function (resp) {
                        $scope.model.queue = resp;
                        $scope.form.queue = JSON.parse(JSON.stringify(resp));

                        TimetableServices.selectTimetableGroupingAppoiment(q, $scope.form, $scope.model);
                        TimetableServices.selectTimetableGrouping(q, $scope.form, $scope.model);
                        FestiveServices.selectFestiveGrouping(q, $scope.form, $scope.model.genericFestiveGrouping);
                        $scope.form.festive = {};
                        $scope.model.festive = {};
                    });
                } else {
                    $scope.model.queue = {};
                    $scope.model.festive = {};
                    $scope.model.timetableGrouping = {};
                    $scope.model.timetableGroupingAppoiment = {};
                    $scope.model.showSaveTimetable = false;
                    $scope.model.showSaveAppointments = false;

                    $scope.form.filter = '';
                    $scope.form.queue = {};
                    $scope.form.festiveGrouping = {};
                    $scope.form.festive = {};
                    $scope.form.timetableGrouping = {};
                    $scope.form.timeTable = {};
                    $scope.form.time = {};
                    $scope.form.timetableGroupingAppoiment = {};
                    $scope.form.timeTableAppoiment = {};
                    $scope.form.timeAppoiment = {};
                }

                APIQueue.loadCode(q.id).then(function (resp) {
                    $scope.form.image_base64 = 'data:image/png;base64,' + resp;
                    $("#qr-code-image").attr('src', $scope.form.image_base64);
                });

                $("#timetableForm").attr("style", "display: none");
                $("#timetableAppointmentForm").attr("style", "display: none");
            };

            $scope.saveTimetable = function () {
                if ($scope.form.timeTable.name === '') {
                    alert("El nombre para el horario es requerido");
                } else {
                    var correct = TimetableServices.assureTimetable($scope.form, TIMETABLE_TYPE.OPEN_CLOSE);
                    if (correct) {
                        TimetableServices.saveTimetable($scope.form, $scope.model);
                    } else {
                        alert("Debe rellenar al menos un día de la semana en el horario");
                    }
                }
            };

            $scope.saveTimetableAppoiment = function () {
                if ($scope.form.timeTableAppoiment.intervalo === 0) {
                    alert("El intervalo entre citas tiene que ser mayor de 0 minutos");
                } else if ($scope.form.timeTableAppoiment.name === '') {
                    alert("El nombre para el horario es requerido");
                } else {
                    var correct = TimetableServices.assureTimetable($scope.form, TIMETABLE_TYPE.APPOINTMENT);
                    if (correct) {
                        TimetableServices.saveTimetableAppoiment($scope.form, $scope.model);
                    } else {
                        alert("Debe rellenar al menos un día de la semana en el horario");
                    }
                }
            };

            $scope.selectTimeTable = function (select) {
                TimetableServices.selectTimeTable(select, $scope.form);
                $("#timetableDetails").attr('open', 'open');
                $("#timetableForm").attr("style", "display: block");
            };

            $scope.selectTimeTableAppoiment = function (select) {
                TimetableServices.selectTimeTableAppoiment(select, $scope.form);
                $("#appointmentDetails").attr('open', 'open');
                $("#timetableAppointmentForm").attr("style", "display: block");
            };

            $scope.removeTimetable = function (timetableId) {
                TimetableServices.removeTimetable(timetableId, $scope.form, $scope.model);
            };

            $scope.removeTimetableAppoiment = function (timetableId) {
                TimetableServices.removeTimetableAppoiment(timetableId, $scope.form, $scope.model);
            };

            $scope.cancelTimetable = function () {
                $scope.form.timeTable = {};
                $scope.form.time = {};
                $("#timetableDetails").removeAttr('open');
                $("#timetableForm").attr("style", "display: block");
            };

            $scope.cancelTimetableAppoiment = function () {
                $scope.form.timeTableAppoiment = {};
                $scope.form.timeAppoiment = {};
                $scope.form.timeTableAppoiment.intervalo = 30;
                $scope.form.timeTableAppoiment.limitHour = 10;
                $("#appointmentDetails").removeAttr('open');
                $("#timetableAppointmentForm").attr("style", "display: block");
            };

            $scope.selectGenericTimeTable = function () {
                TimetableServices.selectGenericTimeTable($scope.form, $scope.model);
            };

            $scope.selectGenericTimeTableAppoiment = function () {
                TimetableServices.selectGenericTimeTableAppoiment($scope.form, $scope.model);
            };

            $scope.selectEspecificTimeTable = function () {
                TimetableServices.selectEspecificTimeTable($scope.form, $scope.model);
            };

            $scope.selectEspecificTimeTableAppoiment = function () {
                TimetableServices.selectEspecificTimeTableAppoiment($scope.form, $scope.model);
            };

            $scope.cancel = function () {
                $scope.select({});
            };

            $scope.cancelFestive = function (q) {
                $scope.form.festive = {};
                $scope.model.festive = {};
            };

            $scope.removeFestive = function (festiveId) {
                FestiveServices.removeFestive(festiveId, $scope.form.queue, $scope.form, $scope.model.genericFestiveGrouping);
            };

            $scope.saveFestiveGrouping = function () {
                FestiveServices.saveFestiveGrouping($scope.form, $scope.model.genericFestiveGrouping);
            };

            $scope.saveFestive = function () {
                FestiveServices.saveFestive($scope.form, $scope.model, $scope.model.genericFestiveGrouping);
            };

            $scope.saveFestiveGrouping = function () {
                FestiveServices.saveFestiveGrouping($scope.form, $scope.model.genericFestiveGrouping);
            };

            $scope.saveFestive = function () {
                FestiveServices.saveFestive($scope.form, $scope.model, $scope.model.genericFestiveGrouping);
            };

            $scope.search = function () {
                APIQueue.forStationWorker(sessionService.getUserId()).then(function (response) {
                    $scope.model.queues = response;
                    $scope.cancel();
                });
            };

            var loadAll = function (id) {

                APIQueue.forStationWorker(sessionService.getUserId()).then(function (response) {

                    if (response && response.length > 0) {
                        $scope.model.queues = _.sortBy(response, function (q) {
                            return q.id;
                        });
                        $scope.select(response[0]);
                    } else {
                        $scope.model.queues = [];
                    }

                    if ($scope.model.genericTimetableGrouping.length > 0) {
                        $scope.form.timetableGrouping.extend = _.find($scope.model.genericTimetableGrouping, ['predetermined', true]);
                    }
                    if ($scope.model.genericTimetableAppoiment.length > 0) {
                        $scope.form.timetableGroupingAppoiment.extend = _.find($scope.model.genericTimetableAppoiment, ['predetermined', true]);
                    }
                });
            };

            loadAll($stateParams.id);

        }
    );