'use strict';

angular.module('bewin_orange')
    .controller('FestiveAdminController', function ($scope, $log, $stateParams, $uibModal, utilService, sessionService,
                                                    modalService, toastr, FestiveAPI, FestiveGroupingAPI) {

        $scope.form = {
            festiveGrouping: {},
            festive: {},
            tab: 1
        };

        $scope.model = {
            listFestiveGrouping: FestiveGroupingAPI.findGenerics().$object,
            festiveGrouping: {},
            festive: {}
        };

        $scope.select = function (festiveGrouping) {
            if (typeof festiveGrouping.id != 'undefined') {
                FestiveGroupingAPI.findOne(festiveGrouping.id).then(function (resp) {
                    $scope.form.festiveGrouping = JSON.parse(JSON.stringify(resp));
                });
            } else {
                $scope.form.festiveGrouping = {};
            }
            $scope.form.festive = {};
            $scope.model.festive = {};
        };

        $scope.cancel = function () {
            $scope.select({});
        };

        $scope.remove = function () {
            $log.log("Borrando>", $scope.form.festiveGrouping);

            var msg = 'Se va a deshabilitar este festivo. ¿Desea continuar?';
            modalService.open('views/common/modal_delete.html', 'DeleteWarningCtrl', msg, null);
            var modalInstance = modalService.modalInstance;

            modalInstance.result.then(function () {
                FestiveGroupingAPI.deleteOne($scope.form.festiveGrouping.id).then(function (r) {
                    toastr.info("Festivo eliminado correctamente", "Operación realizada");
                    loadAll();
                    $scope.cancel();
                });
            });
        };

        $scope.selectFestive = function (festive) {
            if (typeof festive.id != 'undefined') {
                FestiveAPI.findOne(festive.id).then(function (resp) {
                    $scope.model.festive = resp;
                    $scope.form.festive = JSON.parse(JSON.stringify(resp));
                    $scope.form.festive.date = moment(resp.date).format('DD/MM');
                });
            } else {
                $scope.form.festive = {};
                $scope.model.festive = {};
            }
            $scope.form.festive = {};
            $scope.model.festive = {};
        };

        $scope.cancelFestive = function () {
            $scope.selectFestive({});
        };

        $scope.removeFestive = function (festiveId) {
            $log.log("Borrando>", festiveId);

            var msg = 'Se va a deshabilitar este festivo. ¿Desea continuar?';
            modalService.open('views/common/modal_delete.html', 'DeleteWarningCtrl', msg, null);
            var modalInstance = modalService.modalInstance;

            modalInstance.result.then(function () {
                FestiveAPI.deleteOne(festiveId).then(function (r) {
                    toastr.info("Festivo eliminado correctamente", "Operación realizada");
                    $scope.cancelFestive();
                    $scope.select($scope.form.festiveGrouping);
                });
            });
        };

        $scope.save = function () {
            FestiveGroupingAPI.save($scope.form.festiveGrouping).then(function (r) {
                toastr.info("Festive save correctly", "Operación realizada");
                loadAll();
                $scope.select(r);
            });
        };

        $scope.saveFestive = function () {
            $scope.model.festive.date = moment($scope.form.festive.date + '/1900', 'DD/MM/YYYY');
            $scope.model.festive.festiveGrouping = $scope.form.festiveGrouping;
            FestiveAPI.save($scope.model.festive).then(function (r) {
                toastr.info("Festive save correctly", "Operación realizada");
                $scope.cancelFestive();
                $scope.select($scope.form.festiveGrouping);
            });
        };

        var loadAll = function () {
            $scope.model.listFestiveGrouping = FestiveGroupingAPI.findGenerics().$object;
        }

    });