'use strict';

angular.module('bewin_orange')
    .controller('TicketAdminController', function ($scope, $log, $sce, sessionService, modalService, APITicketDesign, toastr) {
        $log.log("TicketAdminController started ..");

        $scope.form = {
            filter: '',
            ticketDesign: {}
        };

        $scope.model = {
            ticketDesigns: APITicketDesign.byTenant(sessionService.getTenantId()).$object,
            ticketDesign: {}
        };


        var showDesign = function () {
            $scope.editHTMLdesign = ($scope.form.ticketDesign.htmlDesign == null) ? true : false;
        };

        var loadAll = function () {
            $scope.model.ticketDesigns = APITicketDesign.byTenant(sessionService.getTenantId()).$object;
        };

        showDesign();


        $scope.cancel = function () {
            $scope.select({});
        };

        $scope.save = function () {

            $log.log("$scope.form.ticketDesign>", $scope.form.ticketDesign);

            if (!$scope.form.ticketDesign.tenant) {
                $scope.form.ticketDesign.tenant = {
                    id: sessionService.getTenantId()
                };
            }

            APITicketDesign.update($scope.form.ticketDesign).then(function (res) {
                $scope.select(res);
                toastr.info("Los datos han sido guardados", "Operación realizada");
                loadAll();
            });
        };

        $scope.select = function (td) {
            $log.log("ticket design > ", td);

            $scope.model.ticketDesign = td;
            $scope.form.ticketDesign = td;
            showDesign();

            if (!td.id) return;
        };

        $scope.remove = function () {

            var msg = 'Se va a deshabilitar el diseño del ticket y ya no se podrá usar en los kioskos ni impresoras portátiles. ¿Desea continuar?';
            modalService.open('views/common/modal_delete.html', 'DeleteWarningCtrl', msg, null);
            var modalInstance = modalService.modalInstance;

            modalInstance.result.then(function () {
                APITicketDesign.deleteOne($scope.form.ticketDesign.id).then(function (r) {
                    toastr.info("Diseño eliminado correctamente", "Operación realizada");
                    loadAll();
                });
                $scope.cancel();
            });
        };

        $scope.renderHtml = function (html_code) {
            return $sce.trustAsHtml(html_code);
        };

        $scope.editDesign = function () {
            $scope.editHTMLdesign = true;
        }
    });
