'use strict';

angular.module('bewin_orange')
    .controller('TimeTableAdminController', function ($filter, $scope, $log, $stateParams, $uibModal, utilService,
                                                      modalService, sessionService, toastr, TimetableGroupingAPI,
                                                      TimetableAPI, TIMETABLE_TYPE, TimetableServices) {

        $scope.form = {
            timetableGrouping: {},
            timeTable: {},
            time: {},
            tab: 1
        };

        $scope.model = {
            listTimetableGrouping: TimetableGroupingAPI.findGenerics(null).$object,
            timetableGrouping: {}
        };

        $scope.constant = TIMETABLE_TYPE;

        $scope.select = function (timetableGrouping) {
            if (typeof timetableGrouping.id != 'undefined') {
                TimetableGroupingAPI.findOne(timetableGrouping.id).then(function (resp) {
                    $scope.model.timetableGrouping = resp;
                    $scope.form.timetableGrouping = JSON.parse(JSON.stringify(resp));

                    $scope.form.timeTable = {};
                    $scope.form.time = {};
                });
            } else {
                $scope.form.timetableGrouping = {};
                $scope.model.timetableGrouping = {};
                $scope.form.timeTable = {};
                $scope.form.time = {};
            }
            angular.element('details').removeAttr('open');
        };

        $scope.cancel = function () {
            $scope.select({});
        };

        $scope.remove = function () {
            $log.log("Borrando>", $scope.form.timetableGrouping);

            var msg = 'Se va a deshabilitar este horario. ¿Desea continuar?';
            modalService.open('views/common/modal_delete.html', 'DeleteWarningCtrl', msg, null);
            var modalInstance = modalService.modalInstance;

            modalInstance.result.then(function () {
                TimetableGroupingAPI.deleteOne($scope.form.timetableGrouping.id).then(function (r) {
                    toastr.info("Horario eliminado con éxito", "Operación realizada");
                    loadAll();
                    $scope.cancel();
                });
            });
        };

        $scope.save = function () {
            TimetableGroupingAPI.save($scope.form.timetableGrouping).then(function (resp) {
                toastr.info("Horario guardado con éxito", "Operación realizada");
                loadAll();
                $scope.select(resp);
            });
        };

        $scope.saveTimetable = function () {
            $scope.form.timeTable = TimetableServices.parseFormToTimetable($scope.form.timeTable, $scope.form.time);
            $scope.form.timeTable.timetableGrouping = $scope.form.timetableGrouping;

            TimetableAPI.save($scope.form.timeTable).then(function (resp) {
                toastr.info("Horario guardado con éxito", "Operación realizada");

                $scope.cancelTimetable();
                $scope.select($scope.form.timetableGrouping);
            });
        };

        $scope.selectTimeTable = function (select) {
            $scope.form.timeTable = JSON.parse(JSON.stringify(select));
            $scope.form.time = TimetableServices.parseTimetableToForm($scope.form.time, $scope.form.timeTable);
            angular.element("details").attr('open', 'open');
        };

        $scope.removeTimetable = function (timetableId) {
            $log.log("Borrando > ", timetableId);

            var msg = 'Se va a deshabilitar este horario. ¿Desea continuar?';
            modalService.open('views/common/modal_delete.html', 'DeleteWarningCtrl', msg, null);
            var modalInstance = modalService.modalInstance;

            modalInstance.result.then(function () {
                TimetableAPI.deleteOne(timetableId).then(function (r) {
                    toastr.info("Horario eliminado con éxito", "Operación realizada");
                    $scope.cancelTimetable();
                    $scope.select($scope.form.timetableGrouping);
                });
            });
        };

        $scope.cancelTimetable = function () {
            $scope.form.timeTable = {};
            $scope.form.time = {};
            angular.element('details').removeAttr('open');
        };

        var loadAll = function () {
            $scope.model.listTimetableGrouping = TimetableGroupingAPI.findGenerics(null).$object;
        };

    });
